#include "AreaLink.h"

#include "tierra.h"
#include "Teclado.h"


// --------------------------------
void AreaLink::Init(strLocalizacion startLoc)
{
  lArea[0]=lArea[1]=lArea[2]=lArea[3]=startLoc;
}


// --------------------------------
void AreaLink::Assign(uchar index, strLocalizacion newLoc)
{
  if(index<4)
    {
      lArea[index]=newLoc;
    }
}

// --------------------------------
void AreaLink::GoTo(uchar index)
{
  if(index<4)
    {
      Navegacion::ME()->setLocalizacion(lArea[index].TierraX,lArea[index].TierraY);
    }
}


// --------------------------------
void AreaLink::OnKeyPess(unsigned char key)
{

  uchar tKey;
  for(uchar l=0;l<4;l++)
    {
      tKey=Teclado::ME()->getKey(255+GLUT_KEY_F5+l);
      if(tKey & 1)
	{
	  if(tKey & 4)
	    {	
	      Assign(l,Navegacion::ME()->getLocalizacion());
	    } 
	  else 
	    {	
	      GoTo(l);
	    }
	}
    }
}


// --------------------------------
strLocalizacion AreaLink::operator [](uint index)
{	
  if(index<4)
    {
      return lArea[index];
    }
  return lArea[0];
}


// --------------------------------
strLocalizacion AreaLink::getAreaLink(uchar index)
{
  if(index<4)
    {	
      return lArea[index];
    }
  return lArea[0];
}
