//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************

#include "Recursos.h"


// -----------------------------
Recursos::Recursos ()
{

  Model NuevoModelo;
  
  Modelo = new Model;
  Modelo->Inicia("Esenarios/Objetos/recurso1",
			   "Esenarios/Objetos/recurso1",
			   "",
			   4.0);
  
}


// -----------------------------
void Recursos::setRetardo(float Retardo)
{
  
}

// -----------------------------
void Recursos::cleanRecurso()
{
  Recursos::TodosLosRecursos.clear();
}

// -----------------------------
void Recursos::putRecurso(float x, float y)
{
  
  RecursoCombustible NuevoRecurso;
  NuevoRecurso.localizacion.x = x;
  NuevoRecurso.localizacion.y = y;
  NuevoRecurso.angulo =  rand() % 360;
  NuevoRecurso.Combustible = 30;
  
  TodosLosRecursos.push_back(NuevoRecurso);

}

// ------------------------------------------
void Recursos::Dibujame()
{

  vector<RecursoCombustible>::iterator Ite;
  float Altura;
  
  glDisable(GL_LIGHTING);
  glEnable(GL_FOG);
  
  glColor4f(1.0, 1.0, 1.0, 1.0);
  
  for(Ite = Recursos::TodosLosRecursos.begin() ; Ite != Recursos::TodosLosRecursos.end() ; Ite++)
    {
      
      Altura = Tierra::ME()->getAltura(Ite->localizacion.x , Ite->localizacion.y);
      Tierra::ME()->fow.SetFogCoord((int)(Ite->localizacion.x *Densidad), (int)(Ite->localizacion.y *Densidad));
      Recursos::Modelo->dibujame(Ite->localizacion.x, Altura, Ite->localizacion.y, 1, Ite->angulo, Ite->angulo);
    }
  
  
  glDisable(GL_FOG);
}

// ------------------------------------------
int Recursos::Recolecta (float x,  float y, float radio)
{
  radio = radio + 0.2;
  vector<RecursoCombustible>::iterator Ite;
  
  for(Ite = TodosLosRecursos.begin() ; Ite != TodosLosRecursos.end() ; Ite++)
    {
      if ( (Ite->localizacion.x < x+radio) && (Ite->localizacion.x > x-radio) )
	{
	  if ( (Ite->localizacion.y < y+radio) && (Ite->localizacion.y > y-radio) )
	    {
	      TodosLosRecursos.erase(Ite);
	      return Ite->Combustible;
	      break;
	    }
	}
    }
  return 0;
}

// -----------------------------


// ----------------------------------
// ----------------------------------
// ------------ RESURSO -------------
// ----------------------------------
// ----------------------------------


// --------------------------
Recurso::Recurso()
{
  Combustible = 0; 
  Electricidad = 0;
}

// --------------------------
bool Recurso::gastaRecursos(int Combustible, int Electricidad)
{
  if ((this->Combustible - Combustible)<0)
    {
      return false;
    }

  if ((this->Electricidad - Electricidad)<0)
    {
      return false;
    }
    
  this->Combustible = this->Combustible - Combustible; 
  this->Electricidad = this->Electricidad - Electricidad;

  return true;
}

// --------------------------
void Recurso::adquiereRecursos(int Combustible, int Electricidad)
{
  this->Combustible = this->Combustible + Combustible; 
  this->Electricidad = this->Electricidad + Electricidad;

}

 
