#ifndef __W3DPlayer_h__
#define __W3DPlayer_h__

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "../constantes.h"

#include <SolarSockets/SolarSockets.h> // Libreria http://solar-opensource.org

#include "W3DPlayerComandos.h"

class W3DPlayer;

#include "W3DServer.h"


class W3DPlayer
{
  
 public:
  int ID;
  string Nick;
  string Army;

  int PosIniX;
  int PosIniY;

  bool Admin;
  bool Listo;
  
  W3DPlayer(int ID, W3DServer *ServerPadre);

 private:
  W3DServer *ServerPadre;
  
  string Comandos;
  vector<W3DPlayerComandoBASE*> W3DPlayerComandos;

 public:
  void ConexionRecive(string Mensaje);
  void Send(string Comando);


 public:
  void sendPOSINI();
  void sendLISTANICKS();
  void sendENTRA();
  void sendADMIN();
    
};


#endif
