#include "Teclado.h"

#include "eventos.h"
#include "pPantallas.h"
#include "AreaLink.h"

#include "ConsolaChat.h"

#include "Solar3DWidGets/Solar3DWidGetEntorno.h"


void Teclado::TecladoEventos(uchar k,int x,int y,bool bSpecial)
{
  if(bSpecial)
    {
      if(k>0 && k<=12)
	{
	  int gMods=glutGetModifiers();
	  key[255+k]=(gMods & GLUT_ACTIVE_ALT)<<1|(gMods & GLUT_ACTIVE_CTRL)<<1|(gMods & GLUT_ACTIVE_SHIFT)<<1|1;
	} else if(k>=100 && k<=108) {
	  int gMods=glutGetModifiers();
	  key[168+k]=(gMods & GLUT_ACTIVE_ALT)<<1|(gMods & GLUT_ACTIVE_CTRL)<<1|(gMods & GLUT_ACTIVE_SHIFT)<<1|1;
	}
      
      switch(Eventos::ME()->getRenderModo())
	{
	case(pModoJuego):
	  {
	    Eventos::ME()->TecladoS(k,x,y);
	    AreaLink::ME()->OnKeyPess(k);
	    break;
	  }
	}
    } else {

      Solar3DWidGetEntorno::ME()->keysEventosPress(k);

      int gMods=glutGetModifiers();
      key[k]=(gMods & GLUT_ACTIVE_ALT)<<1|(gMods & GLUT_ACTIVE_CTRL)<<1|(gMods & GLUT_ACTIVE_SHIFT)<<1|1;
      
      switch(Eventos::ME()->getRenderModo())
	{
	case(pModoPartida):
	  {
	    break;
	  }
	case(pModoJuego):
	  {
	    Eventos::ME()->Teclado(k,x,y);
	    AreaLink::ME()->OnKeyPess(k);
	    ConsolaChat::ME()->charMiTexto(k);

	    break;
	  }
	}
    }

  memset(key,0,277); // Limpiamos 
}
