#ifndef __TECLADO_H__
#define __TECLADO_H__

#include "singleton.h"

#include "constantes.h"

using namespace std;

//byK TypeDefs
typedef unsigned char uchar;
typedef signed char schar;
typedef unsigned short ushort;
typedef signed short sshort;
typedef unsigned long ulong;
typedef signed long slong;
typedef unsigned int uint;
typedef signed int sint;

// ------------------
class Teclado: public singleton<Teclado>
{
 public:

  Teclado(){}
  uchar key[277];

 public:
 
  void TecladoEventos(uchar k,int x=-1,int y=-1,bool bSpecial=false);

//  Que el "unsigned int" no es siempre >=0 ???
//  uchar operator [](uint n){	if(n>=0 && n<=277){	return key[n];	}	}
  uchar operator [](uint n){	if(n<=277){	return key[n];	}	}

//  Que el "unsigned int" no es siempre >=0 ???
//  uchar getKey(uint n){	if(n>=0 && n<=277){	return key[n];	}	}
  uchar getKey(uint n){	if(n<=277){	return key[n]; } return 0;	}
  uchar *getKeyState(){	return key;	};

};

#endif /*__TECLADO_H__*/


