//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIN DE WAR 3D
//*  1.- WAR 3D es un programa que podr ser distribuido bajo los trminos de la Licencia Pblica General, adems debern cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del cdigo para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estar de acuerdo en que el cdigo completo de su programa pasa a ser software libre, por lo deber estar apegado a los trminos establecidos por la licencia LGP. Es decir que, el cdigo de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario abstngase de usar el cdigo o parte de el cdigo de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los crditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podr aadir nuevos nombres en los crditos. Si ha hecho alguna modificacin y quiere que su nombre aparezca en los crditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificacin del cdigo debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el cdigo. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompaarlo con el cdigo fuente completo correspondiente, legible para la mquina, as como el cdigo escrito por usted o las modificaciones hechas al cdigo original.
//*  6.- No debe distribuirse el ejecutable sin el cdigo fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompaarse con la informacin que se recibi as como el ofrecimiento para distribuir el cdigo fuente correspondiente.
//*
//***************************************************************


#ifndef __escribe_h__
#define __escribe_h__

#include <iostream>
#include <string>

using namespace std;

#include "constantes.h"
#include "texturas.h"
#include "zeru_mat.h"

#include <stdio.h>

#include <math.h>

#include "VistasGL.h"



class Texto
{
 private:
  static Textura texFuente1;
  static Textura texFuente2;

  static bool F1Inicializado;
  static bool F2Inicializado;


  VistaGL miVistaGL;

  void EscribeCaracter (char Caracter, float x, float y, float z, float size);

 public:
  void Escribe(float Cadena, float x, float y, int size, int fuente);
  void Escribe(string Cadena, float x, float y, int size, int fuente);
  void Escribe (string Cadena, float x, float y, int size, int fuente, float R, float G, float B, float alpha);
  void Escribe(string Cadena, float x, float y, float z, float angulo, int size, int fuente);
  void Inicia();

};





class TextoTemporal
{
  
 private:

  float x;
  float y;
  int vida;
  int tiempoAnterior;
  string Cadena;
  int size;


  Texto TextServer;

 public:
  
  TextoTemporal();
  ~TextoTemporal();
  void Escribe(float x , float y, string Cadena, int size);
  z2DVector getPosicion();
  void Dibujame();

};


class TextoTemporal2
{
  
 private:

  float x;
  float y;
  int vida;
  int tiempoAnterior;
  string Cadena;
  int size;

  Texto TextServer;

 public:
  
  TextoTemporal2();
  ~TextoTemporal2();
  void Escribe(float x, float y, string Cadena, int size);
  z2DVector getPosicion();
  void Dibujame();

};


#endif



