#ifndef __IslaComandos_h__
#define __IslaComandos_h__

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "../constantes.h"

#include <SolarSockets/SolarSockets.h> // Libreria http://solar-opensource.org

//////////////////////////////
class W3DPlayerComandoBASE
{
 protected:
  string strComando;
  void *Padre;
 public:
  W3DPlayerComandoBASE(string Comando, void* Padre);
  virtual ~W3DPlayerComandoBASE(){};
  bool Accion(string Comando);
 protected:
  virtual void onAccion(vector<string> ComandoParceado) = 0;
};


///////////// ENTR /////////////
class W3DPlayerComandoSETARMY : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoSETARMY(void *Padre):W3DPlayerComandoBASE("SETARMY", Padre){};
  void onAccion (vector<string> ComandoParceado);
};


///////////// ENTR /////////////
class W3DPlayerComandoLISTO : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoLISTO(void *Padre):W3DPlayerComandoBASE("LISTO", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// NICK /////////////
class W3DPlayerComandoNICK : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoNICK(void *Padre):W3DPlayerComandoBASE("NICK", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// CHAT /////////////
class W3DPlayerComandoCHAT : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoCHAT(void *Padre):W3DPlayerComandoBASE("CHAT", Padre){};
  void onAccion (vector<string> ComandoParceado);
};

///////////// START /////////////
class W3DPlayerComandoINICIA : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoINICIA(void *Padre):W3DPlayerComandoBASE("INICIA", Padre){};
  void onAccion (vector<string> ComandoParceado);
};


///////////// AGREGAEDIFICIO /////////////
class W3DPlayerComandoAGREGAEDIFICIO : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoAGREGAEDIFICIO(void *Padre):W3DPlayerComandoBASE("AGREGAEDIFICIO", Padre){};
  void onAccion (vector<string> ComandoParceado);
};


///////////// AGREGASOLDADO /////////////
class W3DPlayerComandoAGREGASOLDADO : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoAGREGASOLDADO(void *Padre):W3DPlayerComandoBASE("AGREGASOLDADO", Padre){};
  void onAccion (vector<string> ComandoParceado);
};


///////////// AGREGASOLDADO /////////////
class W3DPlayerComandoMOD : public W3DPlayerComandoBASE
{
 public:
  W3DPlayerComandoMOD(void *Padre):W3DPlayerComandoBASE("MOD", Padre){};
  void onAccion (vector<string> ComandoParceado);
};



#endif
