//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "SinglePlayer.h"
//#include "eventos.h"

// Este MOdulo es solo para fines de debugueo :P
// dado que War3D estara 100% orientado a MultiPlaying

bool zSolarSocketDataArrivalSinglePlayer (string Mensaje);
void zSolarSocketConectadoSinglePlayer ();

// --------------------------
// --------------------------
// --------------------------

ssClient SinglePlayer::Conexion;
bool SinglePlayer::JuegoIniciado = false;


// --------------------------
SinglePlayer::SinglePlayer()
{
  SinglePlayer::Conexion.setOnDataArrival(zSolarSocketDataArrivalSinglePlayer);
  SinglePlayer::Conexion.setOnConnect(zSolarSocketConectadoSinglePlayer);
}

void SinglePlayer::Inicio()
{	
  SinglePlayer::Conexion.Connect("localhost", 6300);
}

// --------------------------
bool SinglePlayer::ConexionRecive(string Mensaje)
{


  static string Comandos = "";

  Comandos = Comandos + Mensaje;

  int fin;
  string Cadena;

  for (;;)
    {
      
      fin = Comandos.find("\r\n");
      if (fin <= 0) break;
      Cadena = Comandos.substr(0, fin+2);
      Comandos = Comandos.substr(fin+2, 999);
      ConexionComandos(Cadena);
    }

  return true;
}

// --------------------------
bool SinglePlayer::ConexionComandos(string Mensaje)
{

  string Parametros[12];

  parser(Mensaje, Parametros);
  
  
  //cout << "CADENA_SP: " << Mensaje  << endl;
  
  /*
  cout << "  Comando_SP: |" << Parametros[0] << "|" << endl;
  cout << "  Jugador_SP: |" << Parametros[1] << "|" << endl;
  cout << "  Par_1_SP: |" << Parametros[2] << "|" << endl;
  cout << "  Par_2_SP: |" << Parametros[3] << "|" << endl;
  cout << "  Par_3_SP: |" << Parametros[4] << "|" << endl;
  cout << "  Par_4_SP: |" << Parametros[5] << "|" << endl;
  cout << "  Par_5_SP: |" << Parametros[6] << "|" << endl;
  cout << "  Par_6_SP: |" << Parametros[7] << "|" << endl;
  cout << "  Par_7_SP: |" << Parametros[8] << "|" << endl;
  cout << "  Par_8_SP: |" << Parametros[9] << "|" << endl;
  cout << "  Par_9_SP: |" << Parametros[10] << "|" << endl;
  cout << "  Resto_SP: |" << Parametros[11] << "|" << endl;
  */
  
  if (Parametros[0] == "POSINI") //El server nos indica nuestra posicion inicial.
    {
      SinglePlayer::Conexion.Send("LISTO TRUE \r\n");
    }
  else if (Parametros[0] == "CHAT") //Mensaje global enviado por un Jugador
    {
      cout << "MENSAJE: "; 
	  for (int m = 2 ; m < 11 ; m++) cout << Parametros[m] << " ";
	  cout << endl;
    }
  else if (Parametros[0] == "ENNTRA" || Parametros[0] == "LISTADENICKS") // agregar un nuevo ejercito
    {
      SinglePlayer::Conexion.Send("LISTO TRUE \r\n");
    }
  else if (Parametros[0] == "INICIA") // La partida Comienza
    {

      /*
	AddUnidadesMultiplayer();
      */
      SinglePlayer::JuegoIniciado = true;


	  int tipo = 3;
	  float x = 4.0;
	  float y = 8.2;
	  static int ID = 901;
	
	  for (int i = 0; i < 4; i++)
	    {

	      x = x + 0.6;
	      ID ++;

	      char strX[20], strY[20], strBichoID[20], strT[20];
	      
	      sprintf(strT,"%i",tipo);
	      sprintf(strX,"%i",(int)(1000 * x));
	      sprintf(strY,"%i",(int)(1000 * y));
	      sprintf(strBichoID, "%i", (int)(ID % 1000));
	      SinglePlayer::Conexion.Send(string("AGREGAEDIFICIO ") + strT + " " +  strX + " " + strY + " " + strBichoID + "\r\n");
	    }


    }
  else if (Parametros[0] == "AGREGASOLDADO") // Nuevo Bichito
    {

    }


  else if (Parametros[0] == "LISTO")
    {

    }


  else if (Parametros[0] == "CLIMA")
    {

	  cout << "CLIMA BOT: " << Parametros[1] << endl;

      if (Parametros[1] == "DIA")
	  {
	    DiaNoche = true;
	  }
	  else if (Parametros[1] == "NOCHE")
	  {
	    DiaNoche = false;
	  }
    }


  else if (Parametros[0] == "MOD")
    {

    }

  return true;
}


// --------------------------
void SinglePlayer::ConexionConectado()
{  
   cout << "BOT Conectado" << endl;
   switch (rand() %3)
   {
     case 0: Conexion.Send(string ("SETARMY ") + "LosUltimosDeCajosp" + "\r\n"); break;
 	 case 1: Conexion.Send(string ("SETARMY ") + "HYK3" + "\r\n"); break;
	 case 2: Conexion.Send(string ("SETARMY ") + "Eutomats" + "\r\n"); break;
   }
   Conexion.Send(string ("NICK ") + "Bot" + "\r\n");
}


// --------------------------
void SinglePlayer::setRetardo()
{

if	(DiaNoche)
{

  if (SinglePlayer::JuegoIniciado)
  {

  static int NumBicho = 1;
  static int Clock = 55;
  
  static int ID = 101;
  static int IDEspejo = 101;
  
  int i;
  
  Clock++;
   
  if (Clock == 73)
    {
      
      cout << "   [*] Agregando " << NumBicho << " enemigos." << endl;
      
      for (i=0; i<NumBicho ; i++)
	{
	  
	  int tipo = rand() % 6 + 1;
	  float x = float(i)/5.0 + 5.5;
	  float y = 8.8  - NumBicho/15.0;
	  
	  char strX[20], strY[20], strBichoID[20], strT[20];
	  
	  sprintf(strT,"%i",tipo);
	  sprintf(strX,"%i",(int)(1000 * x));
	  sprintf(strY,"%i",(int)(1000 * y));
	  sprintf(strBichoID, "%i", (int)(ID % 1000));
	  
	  SinglePlayer::Conexion.Send(string("AGREGASOLDADO ") + strT + " " +  strX + " " + strY + " " + strBichoID + "\r\n");
	  
	  ID ++;
	  
	}
    }
  
  
  if (Clock == 76)
    {
      
      for (i=0; i<NumBicho ; i++)
	{
	  
	  
	  float x = float(i)/5.0 + 5.5;
	  float y = 8.8 - NumBicho/15.0;

	  cout << IDEspejo << endl;
	  
	  SinglePlayer::Conexion.Send(string("MOD 0") + zitoa(3) + " "
				      + zitoa(IDEspejo%1000) + " "
				      + zitoa((int)((5.0+(rand()%10)/10.0)*1000.0)) + " " 
				      + zitoa((int)(1.0*1000.0)) + " " 
				      + "N" + " " 
				      + "N" + " "
				      +  zitoa((int)(x*1000.0)) + " "
				      +  zitoa((int)(y*1000.0)) + "\r\n");

	  
	  IDEspejo++;
	}
      
      if (NumBicho < 20)
	{
	  NumBicho++;
	}
      SinglePlayer::Conexion.Send("CHAT Donde estas?\r\n");
      
      Clock = 0;
    }
  }
}
}


// --------------------------
void SinglePlayer::parser(string Cadena,string *Parametros)
{
  int i;
  int fin;

  Cadena = Cadena.substr(0,Cadena.size()-2); //Quitamos el "\r\n"

  for (i=0; i<11 ;i++)
    {
      fin = Cadena.find (" ");
      if (fin > 0)
	{
	  Parametros[i] = Cadena.substr(0, fin);
	}
      else
	{
	  Parametros[i] = Cadena;
	  return;
	}
      Cadena = Cadena.substr(fin+1, 99);
    }

  Parametros[i] = Cadena;
 
}

// --------------------------
// --------------------------
// --------------------------


SinglePlayer SinglePlayerBot;

// --------------------------
bool zSolarSocketDataArrivalSinglePlayer (string Mensaje)
{
  // El objeto es un SinglePlayer singleton, por lo que es valido hacer esto. 
  return (SinglePlayerBot.ConexionRecive(Mensaje));
}

// --------------------------
void zSolarSocketConectadoSinglePlayer ()
{
  // El objeto es un SinglePlayer singleton, por lo que es valido hacer esto.
  SinglePlayerBot.ConexionConectado();
}



