// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.

// Solar3DWidGets (c) Solar-OpenSource
// Solar3DWidGets (c) Solar-OpenSource

#include "Solar3DWidGetTextBoxBasico.h"



// -----------------------------------------
Solar3DWidGetTextBoxBasico::Solar3DWidGetTextBoxBasico()
  :Solar3DWidGetBase()
{
  fScroll = 100;
  FontSize = 6;
  FontColor.setColor(0.0, 0.0, 0.3, 1.0);
  onSelecectLine = NULL;
}


// -----------------------------------------
Solar3DWidGetTextBoxBasico::Solar3DWidGetTextBoxBasico(string Nombre, float izq, float arriba, float ancho, float alto)
  :Solar3DWidGetBase(Nombre, izq, arriba, ancho, alto)
{
  fScroll = 100;
  FontSize = 6;
  FontColor.setColor(0.0, 0.0, 0.3, 1.0);
  onSelecectLine = NULL;
}


// -----------------------------------------
void Solar3DWidGetTextBoxBasico::SetFontSize(int Size)
{
  FontSize = Size;
  SetTexto(Text);
}

// -----------------------------------------
void Solar3DWidGetTextBoxBasico::SetTexto(string Text)
{

  int loc;
  int locTmp;

  this->Text = Text;



  

  vector<string> Lineas;

  Text = string("  ") + Text;
  loc = 0;
  while (Text.find("\n", loc+1) != string::npos)
    {
      locTmp = loc;
      loc = Text.find("\n", loc+1);
      Lineas.push_back(Text.substr(locTmp+2, loc-locTmp-2));
    }
  Lineas.push_back(Text.substr(loc+2, 999999));


  Textos.clear();


  for (vector<string>::iterator Ite= Lineas.begin() ; Ite != Lineas.end() ; Ite++)
    {
     

      Text = string(" ") + *Ite + " ";
      loc = 0;
      locTmp = 0;
      while (Text.find(" ", loc+1) != string::npos)
	{
	  
	  locTmp = loc;
	  while (true)
	    {
	      
	      if (Text.find(" ", loc+1)-locTmp > ancho/(FontSize*0.0025))
		{
		  if (locTmp == loc) 
		    {
		      loc = loc + (int)(ancho/(FontSize*0.0025));
		      Textos.push_back(Text.substr(locTmp+1, loc-locTmp-1));
		    }
		  else
		    {
		      Textos.push_back(Text.substr(locTmp+1, loc-locTmp-1));
		    }
		  break;
		}
	      
	      loc = Text.find(" ", loc+1);
	      
	      if (Text.find(" ", loc+1) == string::npos)
	      {
	      Textos.push_back(Text.substr(locTmp+1, 999999));
	      	  break;
	      }
	    }
	}
    }
}

// -----------------------------------------
void Solar3DWidGetTextBoxBasico::SetScroll(float Porcentaje)
{
  fScroll = Porcentaje;
}



// -----------------------------------------
void Solar3DWidGetTextBoxBasico::renderFondo()
{

  if (TexturaDeFondo.isInicializada)
    {
      // Si el Widget tiene textura la usamos.
      ColorDeFondo.usaColor();
      glEnable(GL_TEXTURE_2D);
      TexturaDeFondo.usaGLTextura(TextAltaCalidad);
    }
  else
    {
      // Si el Widget no tiene textura desabilitamos las texturas.
      glDisable(GL_TEXTURE_2D);
    }

  glBegin (GL_QUADS);
  { 
    // Si el Widget tiene textura la usamos.
    if (!TexturaDeFondo.isInicializada) glColor4f(0.8, 0.8, 0.8, 0.75);

    if (TexturaDeFondo.isInicializada) glTexCoord2f(0,1);
    glVertex2f(izq + 00000, arriba + 0000);

    if (!TexturaDeFondo.isInicializada) glColor4f(1.0, 1.0, 1.0, 0.75);

    if (TexturaDeFondo.isInicializada) glTexCoord2f(1,1);
    glVertex2f(izq + ancho, arriba + 0000); 

    if (TexturaDeFondo.isInicializada) glTexCoord2f(1,0);
    glVertex2f(izq + ancho, arriba + alto);

    if (TexturaDeFondo.isInicializada) glTexCoord2f(0,0);
    glVertex2f(izq + 00000, arriba + alto); 
  }
  glEnd();


  glBegin (GL_LINE_LOOP);
  {
    glColor4f(0.0, 0.0, 0.0, 1.0);
    glVertex2f(izq + 00000, arriba + 0000);

    glColor4f(0.2, 0.2, 0.4, 1.0);
    glVertex2f(izq + ancho, arriba + 0000); 
    glVertex2f(izq + ancho, arriba + alto);
    glVertex2f(izq + 00000, arriba + alto); 
  }
  glEnd();

  iScroll = 0;
  if (fScroll>0 && fScroll<=100)
    {
      iScroll = (int)((Textos.size() - int(alto/(FontSize*0.0040)) +1) * (fScroll/100.0));
    }

  if (iScroll < 0) iScroll = 0;

  float Desplazamiento = 0;
  int Lineas = iScroll + (int)(alto/(FontSize*0.0040));
  if (Lineas > (int)Textos.size()) Lineas = (int)Textos.size(); 

  //cout << "Lineas: " << Lineas << "   " << Textos.size() << endl;

  for (int i=iScroll ; i<Lineas; i++)
    {
      TextServer.Escribe(Textos[i], getIzqAbsoluto(), getArribaAbsoluto() + Desplazamiento , FontSize, 1, 
			 FontColor.R, FontColor.G, FontColor.B, FontColor.A);  
      Desplazamiento = Desplazamiento + FontSize * 0.0040;  

      //cout << Textos[i] << endl;

    }
}

// -----------------------------------------
void Solar3DWidGetTextBoxBasico::mouseClic (unsigned int boton, float x, float y)
{
  Solar3DWidGetBase::mouseClic(boton, x, y);
  int Line = (int)(y / (FontSize * 0.0040));
  if ((iScroll + Line < (int)Textos.size()) && (iScroll + Line >= 0))
    {  
      SelectLine(Line, Textos[iScroll+Line]);
    }
}

// -----------------------------------------
void Solar3DWidGetTextBoxBasico::SelectLine(int Line, string Text)
{
  if (onSelecectLine != NULL)
    {
      onSelecectLine(Line, Text, this);
    }
}
