//***************************************************************
//*  [[ A D V E R T E N C I A ]] =[ http://Solar-OpenSource.Org ]=
//*
//*  LICENCIA PARA LA DISTRIBUCIÓN DE WAR 3D
//*  1.- WAR 3D es un programa que podrá ser distribuido bajo los términos de la Licencia Pública General, además deberán cumplirse las siguientes condiciones.
//*  2.- Al copiar cualquier parte del código para ponerlo en un programa diferente a WAR 3D, el autor de dicho programa estará de acuerdo en que el código completo de su programa pasa a ser software libre, por lo deberá estar apegado a los términos establecidos por la licencia LGP. Es decir que, el código de WAR 3D solo puede ser tomado si se va a usar en otro proyecto de software libre. De lo contrario absténgase de usar el código o parte de el código de WAR3D.
//*  3.- Queda estrictamente prohibido modificar los nombres que aparecen en los créditos del programa, solo el grupo de desarrollo de  Solar-OpenSource podrá añadir nuevos nombres en los créditos. Si ha hecho alguna modificación y quiere que su nombre aparezca en los créditos debe ponerse en contacto con nosotros.
//*  4.- Cualquier modificación del código debe apegarse en lo posible a las normas que ha establecido el grupo de desarrollo de Solar-OpenSource, esto es para mayor claridad en el código. Dichas normas pueden encontrarse en nuestra pagina web http://www.solar-opensource.org
//*  5.- Puede copiar y distribuir el programa siempre y cuando no olvide: Acompañarlo con el código fuente completo correspondiente, legible para la máquina, así como el código escrito por usted o las modificaciones hechas al código original.
//*  6.- No debe distribuirse el ejecutable sin el código fuente.
//*  7.- Este texto no debe suprimirse. Las distribuciones deben acompañarse con la información que se recibió así como el ofrecimiento para distribuir el código fuente correspondiente.
//*
//***************************************************************

#include "pantallaMenuPrincipal.h"

#include "Solar3DWidGets/Solar3DWidGetBoton.h"
#include "Solar3DWidGets/Solar3DWidGetLabel.h"
#include "Solar3DWidGets/Solar3DWidGetScroll.h"
#include "Solar3DWidGets/Solar3DWidGetTextBox.h"

#include "eventos.h"

#include "ServerDedicado/W3DServer.h"

#include "pantallaMultiplayerIRC.h"
#include "pantallaInicio.h"

#include "pantallaInicio.h"



// ---------------------------------------
pantallaMenuPrincipal::pantallaMenuPrincipal()
{


  Nombre = "pantallaMenuPrincipal";
  setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/MenuPrincipalFondo.png");
  izq = 0.0;
  alto = 0.0;
  ancho = 1.0;
  alto = 1.0;

  Solar3DWidGetBoton *NuevoBoton;
  
  // ZG Creamos un nuevo boton
  NuevoBoton = new Solar3DWidGetBoton("BotonStartMulti", 0.60, 0.20, 0.35, 0.06, "Multiplayer");
  // NuevoBoton->setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/BotonStartMulti.tga");
  NuevoBoton->onMouseClic = BotonStartMultiClic;

  // ZG Agregamos el nuevo boton al contenedor primario
  agregarHijo(NuevoBoton);
  

  // ZG Creamos un nuevo boton
  NuevoBoton = new Solar3DWidGetBoton("BotonPracticas", 0.60, 0.35, 0.35, 0.06, "Practicas");
  // NuevoBoton->setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/BotonPracticas.tga");
  NuevoBoton->onMouseClic = BotonPracticasClic;

  // ZG Agregamos el nuevo boton al contenedor primario
  agregarHijo(NuevoBoton);



  // ZG Creamos un nuevo boton
  NuevoBoton = new Solar3DWidGetBoton("BotonClientP2P", 0.60, 0.45, 0.35, 0.06, "Conectar a servidor P2P");
  // NuevoBoton->setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/BotonClientP2P.tga");
  NuevoBoton->onMouseClic = BotonClienteP2PClic;

  // ZG Agregamos el nuevo boton al contenedor primario
  agregarHijo(NuevoBoton);



  // ZG Creamos un nuevo boton
  NuevoBoton = new Solar3DWidGetBoton("BotonServerP2P", 0.60, 0.55, 0.35, 0.06, "Iniciar servidor P2P");
  // NuevoBoton->setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/BotonServerP2P.tga");
  NuevoBoton->onMouseClic = BotonServerP2PClic;

  // ZG Agregamos el nuevo boton al contenedor primario
  agregarHijo(NuevoBoton);



  // ZG Creamos un nuevo boton
  NuevoBoton = new Solar3DWidGetBoton("BotonOpciones", 0.60, 0.65, 0.35, 0.06, "Opciones");
  // NuevoBoton->setTexturaDeFondo("Interface/Pantallas/MenuPrincipal/BotonOpciones.tga");
  NuevoBoton->onMouseClic = BotonOpcionesClic;
  NuevoBoton->Enable = false;

  // ZG Agregamos el nuevo boton al contenedor primario
  agregarHijo(NuevoBoton);

  /*

  // ZG. Agregamos un nuevo label.
  Solar3DWidGetLabel * NuevoLabel;

  NuevoLabel = new Solar3DWidGetLabel ("LabelTest", 0.35, 0.20, 0.3, 0.06, "Label Prueba");
  NuevoLabel->FontColor.setColor(1.0, 0.0 ,0.0, 1.0);

  agregarHijo(NuevoLabel);

  
  // ZG. 
  Solar3DWidGetScroll * NuevoScroll;
  NuevoScroll = new Solar3DWidGetScroll ("ScrollTest", 0.15, 0.20, 0.03, 0.3);

  agregarHijo(NuevoScroll);
  

  // ZG. 
  Solar3DWidGetTextBox * NuevotextBox;
  NuevotextBox = new Solar3DWidGetTextBox ("ScrollTest", 0.01, 0.60, 0.3, 0.30);


  string Texto;
  Texto += "Text Box Basico:" + (char)13;
  Texto += "Ultimamente el proyecto entro en un estado de letargo muy prolongado, pero ya esta reviviendo de nuevo." + char(13);
  Texto += "Por ahora estamos trabajando en una libreria de WidGets, es decir controles visuales como botones, labels, ";
  Texto += "comobobox, memos, etc. FIN";

  NuevotextBox->SetTexto(Texto);
  NuevotextBox->SetFontSize(6);

  agregarHijo(NuevotextBox);
 */ 

}

// ---------------------------------------
void pantallaMenuPrincipal::BotonStartMultiClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  Eventos::ME()->SetRenderModo(pModoMultiplayer);
  pantallaMultiplayerIRC::ME()->Clean();
  pantallaMultiplayerIRC::ME()->Conectar(IRCServer);
}


// ---------------------------------------
void pantallaMenuPrincipal::BotonPracticasClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{

  W3DServer::ME()->Inicializa();

  cout << "Starting single player game..." << endl;

  configuracion::Server = "SINGLEPLAYER";
  Eventos::ME()->SetRenderModo(pModoPartida);

  cout << "Conectando ..." << endl;
  pantallaInicio::ME()->Conectar("localhost");


  /*
  if (configuracion::Server != "") 
    {
      // if they do not automatically start in server mode
      // than we want them to default to the main menu.
      
      if (configuracion::Server == "SERVER")
	{
	  configuracion::Server = "localhost";
	}
      
      Eventos::ME()->SetRenderModo(pModoPartida);
      
      cout << "Conectando ..." << endl;
      W3DCliente::ME()->Conectar(configuracion::Server);
    }
  else
    {
      Eventos::ME()->SetRenderModo(pModoPartida);
      
      cout << "Conectando ..." << endl;
      W3DCliente::ME()->Conectar("localhost"); 
    }
  */
}

// ---------------------------------------
void pantallaMenuPrincipal::BotonServerP2PClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaInicio::ME()->setRoll(pantallaNuevaPartidaRollServer);
  Eventos::ME()->SetRenderModo(pModoNuevaPartida);
}

// ---------------------------------------
void pantallaMenuPrincipal::BotonClienteP2PClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{
  pantallaInicio::ME()->setRoll(pantallaNuevaPartidaRollCliente);
  Eventos::ME()->SetRenderModo(pModoClienteP2P);
}

// ---------------------------------------
void pantallaMenuPrincipal::BotonOpcionesClic(unsigned int boton, float x, float y, Solar3DWidGetBase* This)
{

}
